package com.hisschemoller.utils.midi 
{	
	/**
	 * @author Wouter Hisschemöller
	 * (c) May 13, 2009
	 * 
	 * <!-- sysex -->
	 * 1 - F0 : start of sysex message
	 * 2 - 00 : Manufacturer ID
	 * 3 - 00 : Model ID
	 * 4 - 00 : Device ID (7F = all devices)
	 * 5 - 00 : The actual data (01 = start of pattern, 02 = end of pattern)
	 * 6 - 00 : Checksum
	 * 7 - F7 : end of sysex message
	 */
	public class MidiSysExVO extends MidiEventVO
	{
		public var data : uint;

		public function MidiSysExVO()
		{
			type = MidiEventType.SYS_EX;
			channel = MidiSpecification.SYSEX_CHANNEL;
		}

		override public function parseXML(o : XML) : Boolean
		{
			var success : Boolean = super.parseXML(o);
			
			var sysExString : Array = o.*[1].split(" ");
			
			data = parseInt(sysExString[4], 16);
			
			return success;
		}
	}
}
